LintCode 1346: Dungeon Game (DP好题)

2023-10-16 07:48

本文主要是介绍LintCode 1346: Dungeon Game (DP好题),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Description

中文English

The demons had captured the princess (P) and imprisoned her in the bottom-right corner of a dungeon. The dungeon consists of M x N rooms laid out in a 2D grid. Our valiant knight (K) was initially positioned in the top-left room and must fight his way through the dungeon to rescue the princess.

The knight has an initial health point represented by a positive integer. If at any point his health point drops to 0 or below, he dies immediately.

Some of the rooms are guarded by demons, so the knight loses health (negative integers) upon entering these rooms; other rooms are either empty (0's) or contain magic orbs that increase the knight's health (positive integers).

In order to reach the princess as quickly as possible, the knight decides to move only rightward or downward in each step.

Write a function to determine the knight's minimum initial health so that he is able to rescue the princess.

For example, given the dungeon below, the initial health of the knight must be at least 7 if he follows the optimal path RIGHT-> RIGHT -> DOWN -> DOWN.

| -2(K)   | -3     | 3        |
| -5      | -10    | 1        |
| 10      | 30     | -5(P)    |

 

The knight's health has no upper bound.
Any room can contain threats or power-ups, even the first room the knight enters and the bottom-right room where the princess is imprisoned.

 

解法1:DP。

注意这题不能用BFS。因为BFS是求最短路径或者可行解。而这里是求最优路径或最优值。这里最优路径未必最短,用BFS不可行,但是用DP是可行的。

DP思路就是从后往前倒推。dp[i][j]表示房间[i][j]王子初来的时候的最小应该满足的血值。

1)注意从公主的右侧和下侧房间开始,王子的血应该是1。

2)每个房间的王子初来的血值应该等于其右侧和下侧房间的血的最小值减去该房间本来的血值,但至少要为1。

3)每个房间的初始值设为INT_MAX。

class Solution {
public:/*** @param dungeon: a 2D array* @return: return a integer*/int calculateMinimumHP(vector<vector<int>> &dungeon) {int nRow = dungeon.size();int nCol = dungeon[0].size();vector<vector<int>> dp(nRow + 1, vector<int>(nCol + 1, INT_MAX));dp[nRow][nCol - 1] = 1;dp[nRow - 1][nCol] = 1;for (int i = nRow - 1; i >= 0; --i) {for (int j = nCol - 1; j >= 0; --j) {dp[i][j] = max(1, min(dp[i + 1][j], dp[i][j + 1]) - dungeon[i][j]);}}return dp[0][0];}
};

解法2:DP+空间优化

class Solution {
public:/*** @param dungeon: a 2D array* @return: return a integer*/int calculateMinimumHP(vector<vector<int>> &dungeon) {int nRow = dungeon.size();int nCol = dungeon[0].size();vector<int> dp(nCol + 1, INT_MAX);dp[nCol - 1] = 1;for (int i = nRow - 1; i >= 0; --i) {for (int j = nCol - 1; j >= 0; --j) {dp[j] = max(1, min(dp[j], dp[j + 1]) - dungeon[i][j]);}}return dp[0];}
};

为什么这里空间可以优化呢?这个实际上和01背包问题的优化是一样的,

注意
dp[j] = max(1, min(dp[j], dp[j + 1]) - dungeon[i][j]);

dp[i][j] = max(1, min(dp[i + 1][j], dp[i][j + 1]) - dungeon[i][j]);
是等价的。

对解法1来说,因为i和j都是从大到小,所以每次都是先计算dp[i+1][j], dp[i][j+1],然后再计算dp[i][j]。
对于每个i,j循环结束后,得到dp[i][0],即房间[i][0]的王子初入血值。
而这个也就是解法2中,每个i,j循环结束后得到的dp[j]的值。

 

解法3:二分+DP

总体效率不如解法1和解法2。下次做。

这篇关于LintCode 1346: Dungeon Game (DP好题)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/220083

相关文章

好题——hdu2522(小数问题:求1/n的第一个循环节)

好喜欢这题,第一次做小数问题,一开始真心没思路,然后参考了网上的一些资料。 知识点***********************************无限不循环小数即无理数,不能写作两整数之比*****************************(一开始没想到,小学没学好) 此题1/n肯定是一个有限循环小数,了解这些后就能做此题了。 按照除法的机制,用一个函数表示出来就可以了,代码如下

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o